var Subject_1 = require('./Subject');
var Scheduler_1 = require('./Scheduler');
var Observable_1 = require('./Observable');
var Subscriber_1 = require('./Subscriber');
var Subscription_1 = require('./Subscription');
var Notification_1 = require('./Notification');
var ReplaySubject_1 = require('./subjects/ReplaySubject');
var BehaviorSubject_1 = require('./subjects/BehaviorSubject');
var ConnectableObservable_1 = require('./observables/ConnectableObservable');
var ArrayObservable_1 = require('./observables/ArrayObservable');
var DeferObservable_1 = require('./observables/DeferObservable');
var EmptyObservable_1 = require('./observables/EmptyObservable');
var ErrorObservable_1 = require('./observables/ErrorObservable');
var InfiniteObservable_1 = require('./observables/InfiniteObservable');
var IntervalObservable_1 = require('./observables/IntervalObservable');
var IteratorObservable_1 = require('./observables/IteratorObservable');
var PromiseObservable_1 = require('./observables/PromiseObservable');
var RangeObservable_1 = require('./observables/RangeObservable');
var ScalarObservable_1 = require('./observables/ScalarObservable');
var TimerObservable_1 = require('./observables/TimerObservable');
var FromEventPatternObservable_1 = require('./observables/FromEventPatternObservable');
var FromEventObservable_1 = require('./observables/FromEventObservable');
Observable_1.default.defer = DeferObservable_1.default.create;
Observable_1.default.from = IteratorObservable_1.default.create;
Observable_1.default.fromArray = ArrayObservable_1.default.create;
Observable_1.default.fromPromise = PromiseObservable_1.default.create;
Observable_1.default.of = ArrayObservable_1.default.of;
Observable_1.default.range = RangeObservable_1.default.create;
Observable_1.default.fromEventPattern = FromEventPatternObservable_1.default.create;
Observable_1.default.just = ScalarObservable_1.default.create;
Observable_1.default.return = ScalarObservable_1.default.create;
Observable_1.default.value = ScalarObservable_1.default.create;
Observable_1.default.throw = ErrorObservable_1.default.create;
Observable_1.default.empty = EmptyObservable_1.default.create;
Observable_1.default.never = InfiniteObservable_1.default.create;
Observable_1.default.timer = TimerObservable_1.default.create;
Observable_1.default.interval = IntervalObservable_1.default.create;
Observable_1.default.fromEvent = FromEventObservable_1.default.create;
var observableProto = Observable_1.default.prototype;
var concat_1 = require('./operators/concat');
var concatAll_1 = require('./operators/concatAll');
var concatMap_1 = require('./operators/concatMap');
var concatMapTo_1 = require('./operators/concatMapTo');
Observable_1.default.concat = concat_1.default;
observableProto.concat = concat_1.default;
observableProto.concatAll = concatAll_1.default;
observableProto.concatMap = concatMap_1.default;
observableProto.concatMapTo = concatMapTo_1.default;
var merge_1 = require('./operators/merge');
var mergeAll_1 = require('./operators/mergeAll');
var flatMap_1 = require('./operators/flatMap');
var flatMapTo_1 = require('./operators/flatMapTo');
var switchAll_1 = require('./operators/switchAll');
var switchLatest_1 = require('./operators/switchLatest');
var switchLatestTo_1 = require('./operators/switchLatestTo');
var expand_1 = require('./operators/expand');
Observable_1.default.merge = merge_1.default;
observableProto.merge = merge_1.default;
observableProto.mergeAll = mergeAll_1.default;
observableProto.flatMap = flatMap_1.default;
observableProto.flatMapTo = flatMapTo_1.default;
observableProto.switchAll = switchAll_1.default;
observableProto.switchLatest = switchLatest_1.default;
observableProto.switchLatestTo = switchLatestTo_1.default;
observableProto.expand = expand_1.default;
var map_1 = require('./operators/map');
var mapTo_1 = require('./operators/mapTo');
var toArray_1 = require('./operators/toArray');
var scan_1 = require('./operators/scan');
var reduce_1 = require('./operators/reduce');
var startWith_1 = require('./operators/startWith');
observableProto.map = map_1.default;
observableProto.mapTo = mapTo_1.default;
observableProto.toArray = toArray_1.default;
observableProto.scan = scan_1.default;
observableProto.reduce = reduce_1.default;
observableProto.startWith = startWith_1.default;
var take_1 = require('./operators/take');
var skip_1 = require('./operators/skip');
var takeUntil_1 = require('./operators/takeUntil');
var filter_1 = require('./operators/filter');
var distinctUntilChanged_1 = require('./operators/distinctUntilChanged');
var distinctUntilKeyChanged_1 = require('./operators/distinctUntilKeyChanged');
observableProto.take = take_1.default;
observableProto.skip = skip_1.default;
observableProto.takeUntil = takeUntil_1.default;
observableProto.filter = filter_1.default;
observableProto.distinctUntilChanged = distinctUntilChanged_1.default;
observableProto.distinctUntilKeyChanged = distinctUntilKeyChanged_1.default;
var combineLatest_1 = require('./operators/combineLatest');
var combineAll_1 = require('./operators/combineAll');
Observable_1.default.combineLatest = combineLatest_1.default;
observableProto.combineLatest = combineLatest_1.default;
observableProto.combineAll = combineAll_1.default;
var zip_1 = require('./operators/zip');
var zipAll_1 = require('./operators/zipAll');
Observable_1.default.zip = zip_1.default;
observableProto.zip = zip_1.default;
observableProto.zipAll = zipAll_1.default;
var publish_1 = require('./operators/publish');
var multicast_1 = require('./operators/multicast');
observableProto.publish = publish_1.default;
observableProto.multicast = multicast_1.default;
var observeOn_1 = require('./operators/observeOn');
var subscribeOn_1 = require('./operators/subscribeOn');
observableProto.observeOn = observeOn_1.default;
observableProto.subscribeOn = subscribeOn_1.default;
var partition_1 = require('./operators/partition');
var toPromise_1 = require('./operators/toPromise');
var defaultIfEmpty_1 = require('./operators/defaultIfEmpty');
var materialize_1 = require('./operators/materialize');
observableProto.partition = partition_1.default;
observableProto.toPromise = toPromise_1.default;
observableProto.defaultIfEmpty = defaultIfEmpty_1.default;
observableProto.materialize = materialize_1.default;
var catch_1 = require('./operators/catch');
var retryWhen_1 = require('./operators/retryWhen');
observableProto.catch = catch_1.default;
observableProto.retryWhen = retryWhen_1.default;
var finally_1 = require('./operators/finally');
observableProto.finally = finally_1.default;
exports.default = {
    Subject: Subject_1.default,
    Scheduler: Scheduler_1.default,
    Observable: Observable_1.default,
    Subscriber: Subscriber_1.default,
    Subscription: Subscription_1.default,
    ReplaySubject: ReplaySubject_1.default,
    BehaviorSubject: BehaviorSubject_1.default,
    ConnectableObservable: ConnectableObservable_1.default,
    Notification: Notification_1.default
};
